<%
constructor_params = 'id = null, '
constructor_params += attributes.keys.reject{ |a| a == 'id' }.join(', ')

url_base       = "api/#{model_name.pluralize.underscore}"
%>import Model from './Model'

/**
 * List of attributes that can be updated in `updateAttributes()`
 *
 * @type {string[]}
 */
const ATTRIBUTES = [<%= attributes.keys.reject{|a| a == 'id'}.map{|a| "'#{a.camelize(:lower)}'"}.join(', ') %>]

class <%= model_name %> extends Model {
  /* eslint-disable camelcase, jsdoc/require-param-description */
  /**
   * @param {object} payload - Data from API<% attributes.each do |param, details| %>
   * @param {<%= attribute_type(param, details) %>} payload.<%= param %><% end %>
   */
  constructor ({ <%= constructor_params %> }) {
    super()<% attributes.each do |param, details| %>
    this.<%= param.camelize(:lower) %> = <%=attribute_setter(param, details) %><% end %>
  }
  /* eslint-enable camelcase, jsdoc/require-param-description */

  /**
   * @returns {string}  The hardcoded class name
   */
  static getClassName () { return '<%= model_name %>' }
}

<%= model_name %>.updatableAttributes = ATTRIBUTES
<%= model_name %>.urls = {
  index () { return '/<%= url_base %>' },
  show (id) { return `/<%= url_base %>/${id}` },
  create () { return '/<%= url_base %>' },
  update (payload) { return `/<%= url_base %>/${payload.id}` },
  destroy (id) { return `/<%= url_base %>/${id}` },
}

export default <%= model_name %>
